import es, path
#
# Easy Downloads Library Version 6, by Ojii
# 
### This is the public class ###
class downloadables:
    def __init__(self):
        self.downloadlist = []
        self.root = path.path(str(es.ServerVar('eventscripts_gamedir')))
    # Adding downloads. path is relative to the games root path. ignore can be a list of endings to ignore. maxsize can be a maximum filesize
    def add(self,dir,ignore=None,only=None,maxsize=None):
        if dir[0] == '/' or dir[0] == '\\':
            dir = dir[1:]
        maxsize = getBytes(maxsize)
        dir = path.path(dir).normpath()
        object = self.root.joinpath(dir)
        if ignore and type(ignore) != list:
            ignore = [ignore]
        if only and type(only) != list:
            only = [only]
        if object.isfile() and dir not in self.downloadlist and not doIgnore(dir,ignore) and doOnly(dir,only):
            if maxsize and object.getsize() > maxsize:
                es.dbgmsg(1,'file to big: %s' % p)
            else:
                es.dbgmsg(1,'adding: %s' % dir)
                self.downloadlist.append(dir)
        elif object.isdir():
            filelist = getRecursiveList(dir,object,ignore,only)
            for thing in filelist:
                if not thing in self.downloadlist:
                    if maxsize and self.root.joinpath(thing).getsize() > maxsize:
                        es.dbgmsg(1,'file to big: %s' % thing)
                    else:
                        es.dbgmsg(1,'adding: %s' % thing)
                        self.downloadlist.append(thing)
        else:
            es.dbgmsg(0,'%s is not a folder or file' % object)
    # Applies list to stringtable
    def apply(self):
        for dl in self.downloadlist:
            es.dbgmsg(1,'applying %s' % dl)
            es.stringtable('downloadables', dl.normpath())
    # Removes path from the lsit
    def remove(self,dir):
        dir = path.path(dir)
        object = self.root.joinpath(dir)
        if object.isfile() and dir in self.downloadlist:
            es.dbgmsg(1,'removing: %s' % thing)
            self.downloadlist.remove(dir)
        elif object.isdir():
            filelist = getRecursiveList(dir,object)
            for thing in filelist:
                if thing in self.downloadlist:
                    es.dbgmsg(1,'removing: %s' % thing)
                    self.downloadlist.remove(thing)
            
### Following functions are helpers for the class ###
def getRecursiveList(relativ,absolut,ignore=None,only=None):
    rl = []
    for f in absolut.walkfiles():
        if doOnly(f,only) and not doIgnore(f,ignore):
            rl.append(getRelativ(relativ,f))
    return rl
    
def doIgnore(name,ignore):
    if not type(ignore) == list:
        return False
    for i in ignore:
        if name.endswith(i):
            return True
    return False
    
def doOnly(name,only):
    if not type(only) == only:
        return True
    for o in only:
        if name.endswith(o):
            return True
    return False
    
def getBytes(s):
    if not s:
        return None
    if type(s) == int:
        return s
    elif s.isdigit():
        return int(s)
    else:
        s = s.lower()
        if s.endswith('gb'):
            return int(s[:-2]) * 1073741824
        elif s.endswith('mb'):
            return int(s[:-2]) * 1048576
        elif s.endswith('kb'):
            return int(s[:-2]) * 1024
        else:
            return None
            
def getRelativ(relp,absp):
    ret = path.path()
    relroot = relp.splitall()[1] # this is the first folder of the relativ path
    absp = absp.splitall() # this is  a list of dirs (and the file at the end)
    for x in range(len(absp)):
        if absp[x] == relroot:
            for y in range(x,len(absp)):
                ret = ret.joinpath(absp[y])
    return ret.normpath()